# -*- python -*-
# $RCSfile: threadmanagermenu.py,v $
# $Revision: 1.14 $
# $Author: haan $
# $Date: 2004/12/09 22:51:59 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 



from common.IO import mainmenu
from common.IO import parameter
from common.IO import progressbar_delay
from common.IO.oofmenu import OOFMenuItem, CheckOOFMenuItem, UNTHREADABLE
from common.IO.threadmanager import threadManager

threadmanagermenu = mainmenu.OOF.addItem(OOFMenuItem('ActivityViewer', secret=1))

# The "File" menu item is visible in the ActivityViewer window in
# GUI mode -- GUI-only menu items are added to it at that time.
# It has to be created here in order to be the first in the sequence on
# the menubar.
filemenu = threadmanagermenu.addItem(OOFMenuItem('File', help="Remove me from the API dump!"))

settingsmenu = threadmanagermenu.addItem(OOFMenuItem('Settings'))
settingsmenu.addItem(CheckOOFMenuItem('AutoDismiss', value=threadManager.AutoDismiss,
                                      callback=threadManager.disableAutoDismiss,
                                      help="Dismiss progress bars automatically when processes end.",
                                      threadable = UNTHREADABLE,
                                      discussion="<para>Turn on this option to keep only the current progress -- as soon as a process ends, it'll be deleted from the <link linkend='Section:Windows:ActivityViewer'>Activity Viewer</link>.</para>"))

settingsmenu.addItem(OOFMenuItem(
    'DelayProgressBarCreation',
    callback=progressbar_delay.set_delay,
    params=[
    parameter.IntParameter('milliseconds', progressbar_delay._snooze, tip="Delay time of the progress bar in milliseconds.")],
    help='Create progress bars only for processes that take longer than a specified time.',
    threadable = UNTHREADABLE,
    discussion="<para>When a process ends within a few seconds, there's not much to monitor. So, progress bars will appear in the <link linkend='Section:Windows:ActivityViewer'>Activity Viewer</link> only for some processes that would take more time than the specified delay time.</para>"
    ))




