# -*- python -*-
# $RCSfile: meshbdymenu.py,v $
# $Revision: 1.5 $
# $Author: haan $
# $Date: 2004/11/10 15:39:14 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Menu items for post-solution actions on boundaries.
from SWIG.engine.IO import bdyflux
from common.IO import automatic
from common.IO import oofmenu
from common.IO import parameter
from common.IO import destinationparam
from common.IO import reporter
from common.IO import whoville
from engine.IO import meshmenu
from engine.IO import meshparameters
from engine.IO import skeletongroupparams # For boundary param class.
import engine.mesh

meshmenutop = meshmenu.meshmenu

meshbdymenu = meshmenutop.addItem(
    oofmenu.OOFMenuItem('Boundary',secret=1) )

# This parameter class gets a widget in skeletongroupwidgets.py -- the
# unintuitive location of the widget code is because its widget is a
# descendant of the ContextBoundaryWidget class, and works for both
# meshes and skeleti.

class EdgeBoundaryParameter(parameter.StringParameter):
    pass

# "mesh" and "boundary" are strings, "flux" is an object, and
# "destination" is a filename or "automatic".
def _integrateFlux(menuitem, mesh, boundary, flux, destination):
    fe_mesh = engine.mesh.meshes[mesh].getObject()
    edgeset = fe_mesh.getBoundary(boundary).edgeset
    outfile = destinationparam.get_file(destination)
    res = bdyflux.integrate(fe_mesh, flux, edgeset)
    print >> outfile, res
    



meshbdymenu.addItem(
    oofmenu.OOFMenuItem('Integrate_Flux',
                        callback=_integrateFlux,
                        params=[
    whoville.WhoParameter('mesh', engine.mesh.meshes,
                          tip=parameter.emptyTipString),
    EdgeBoundaryParameter('boundary', tip="Target boundary."),
    meshparameters.FluxParameter('flux', tip=parameter.emptyTipString),
    destinationparam.DestinationParameter(
    'destination',value=automatic.automatic, tip="Where to put the result?")
    ],
                        help="Integrate Flux over a specified boundary."))
