# -*- python -*-
# $RCSfile: meshqualityexpansion_.py,v $
# $Revision: 1.9 $
# $Author: haan $
# $Date: 2004/11/10 15:39:16 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.common import devel
from SWIG.engine import symmmatrix
from common import utils
from common.IO import parameter
from engine import problem
from engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration
if devel.devel():
    SkeletonExpansionTensor = PropertyRegistration(
        'Thermal:ThermalExpansion:MeshExpansion', MeshExpansion,
        "SWIG.engine.property.meshqualityexpansion.meshqualityexpansion",9000,
        [symmmatrix.SymmMatrix3Parameter('alpha',
                                         symmmatrix.SymmMatrix3(1., 1., 1.,
                                                                0., 0., 0.),
                                         tip=parameter.emptyTipString),
         parameter.FloatParameter('t0', -1.0, tip=parameter.emptyTipString)],
        fields=[problem.Temperature],
        fluxes=[problem.Stress],
        outputs=["Strain"],
        propertyType="MeshExpansion",
        nonlinear=1)
    

# Property reprs refer to the registered name, not the actual class name.
def _MeshExpansion___repr__(self):
    return "MeshExpansion(name='%s', alpha=%s, t0=%s)" % \
           (self.name(), `self.kappa()`, `self.tzero()`)

MeshExpansionPtr.__repr__ = _MeshExpansion___repr__
