# -*- python -*-
# $RCSfile: orientation_.py,v $
# $Revision: 1.14 $
# $Author: haan $
# $Date: 2004/11/10 15:39:16 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from common.IO import parameter
Parameter = parameter.Parameter

from engine.IO import orientationmatrix
Orientation = orientationmatrix.Orientation
Abg = orientationmatrix.Abg

orientationReg = PropertyRegistration(
   'Orientation', OrientationProp,
   "SWIG.engine.property.orientation.orientation",200,
   [parameter.RegisteredParameter('angles', Orientation,
                                  Abg(0.0, 0.0, 0.0),
                                  tip=parameter.emptyTipString)],
   propertyType="Orientation")

def _Orientation_eulerparam(self):
    angle = self.eulerangle()
    return Abg(angle.alpha(), angle.beta(), angle.gamma())

OrientationPropPtr.eulerparam = _Orientation_eulerparam

# Repr refers to registered name, not classname.  See comments
# in elasticity/iso/iso_.py for reasons why.
def _Orientation___repr__(self):
    return "Orientation(name='%s', angles=%s)" % \
           (self.name(), `self.eulerparam()`)

OrientationPropPtr.__repr__ = _Orientation___repr__

