# -*- python -*-
# $RCSfile: pixelselectionmod.py,v $
# $Revision: 1.7 $
# $Author: haan $
# $Date: 2004/12/10 23:11:05 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

## Pixel selection modifiers make selections without mouse input.

from SWIG.image import pixelselectioncourieri
from common import color
from common import pixelselectionmod
from common import registeredclass
from common.IO import colordiffparameter
from common.IO import parameter
from common.IO import whoville

class ColorRange(pixelselectionmod.SelectionModifier):
    def __init__(self, image, reference, range):
        self.image = image
        self.reference = reference
        self.range = range
    def __call__(self, ms, selection):
        curselection = selection.getObject()
        # 'cause my teeth are perly...
        image = whoville.getClass('Image')[self.image]
        imageobj = image.getObject()
        ms = image.getMicrostructure()
        selection.start()
        selection.clearAndSelect(
            pixelselectioncourieri.ColorSelection(ms, imageobj,
                                                  self.reference, self.range))

registeredclass.Registration('Color Range',
                             pixelselectionmod.SelectionModifier,
                             ColorRange,
                             ordering=3.14,
                             params=[
    whoville.WhoParameter('image', whoville.getClass('Image'), tip=parameter.emptyTipString),
    color.NewColorParameter('reference', tip='Reference color.'),
    colordiffparameter.ColorDifferenceParameter('range', tip='Color tolerence from the reference color.')],
                             tip="Select all pixels within the given color range of the indicated reference color.",
                             discussion=
                             """<para>It basically does the same thing that <xref linkend='MenuItem:OOF.Graphics_n.Toolbox.Pixel_Select.Color'/> does except the latter takes its <varname>reference</varname> input directly from the pixel that is clicked.</para>""")
